<template>
    <q-dialog class="home">
        <q-card class="border-radius-50 q-pa-sm" style="width: 335px">
            <q-card-section class="row items-center row justify-center">
                <!-- Title -->
                <div class="col-12 items-center row justify-center">
                    <span
                        class="font-16 text-center helvetica-neue-medium"
                        no-caps
                    >
                        Select Image
                    </span>
                </div>
                <div class="col-12 items-center row justify-center q-mt-lg">
                    <q-file
                        standout
                        color="transparent"
                        bg-color="transparent"
                        borderless
                        class="img-input"
                        accept=".jpg, image/*"
                        v-model="file"
                        display-value=""
                        :multiple="multiple"
                    >
                        <template v-slot:append>
                            <q-avatar>
                                <q-icon
                                    size="sm"
                                    class="img-picker"
                                    name="img:icons\upload.png"
                                />
                            </q-avatar>
                        </template>
                    </q-file>
                    <!--  <q-file v-model="file" label="Pick one file" filled style="max-width: 300px" /> -->
                </div>
                <div
                    class="
                        col-12
                        items-center
                        text-center
                        helvetica-neue-medium
                        row
                        justify-center
                        q-mt-lg
                    "
                >
                    Upload File
                </div>
            </q-card-section>
        </q-card>
    </q-dialog>
</template>

<style scoped>
.img-picker {
    position: absolute;
    top: 145%;
    right: 160%;
    z-index: 10;
    width: 35px;
}
</style>

<script lang="ts">
import { defineComponent, ref, reactive, watch } from 'vue';
import { useStore } from 'src/store';
import { mapGetters } from 'vuex';

export default defineComponent({
    computed: {
        ...mapGetters({
            user: 'user/getUser'
        })
    },
    props: {
        confirm: {
            type: Boolean,
            required: true
        },
        imageType: {
            type: String,
            required: true
        },
        multiple: {
            type: Boolean,
            default: false
        }
    },
    setup(props, { emit }) {
        const store = useStore();
        const search = ref('');
        const file = ref<File[]>();

        let state = reactive({
            loadingState: ref(false),
            searchResults: ref(false),
            selectedUserID: '',
            type: props.imageType as any
        });

        watch(file, async (currentValue) => {
            if (currentValue) {
                // Multiple Image
                if (props.multiple && file.value) {
                    let fileResult: any = [];
                    let count = 0;
                    // eslint-disable-next-line @typescript-eslint/no-misused-promises
                    file.value.forEach(async (element: any, index, array) => {
                        const result = await store.dispatch(
                            'file/avatarUpload',
                            {
                                file: element
                            }
                        );
                        fileResult.push(result.path);
                        count++;
                        if (count === array.length) {
                            updateAvatar(false, Object.values(fileResult));
                        }
                    });
                }
                // One Image
                else {
                    const result = await store.dispatch('file/avatarUpload', {
                        file: file.value
                    });
                    await updateAvatar(false, result);
                }
            }
        });

        const updateAvatar = (value: any, file: any) => {
            emit('update-confirm', value, file);
            return value;
        };

        const checkFileType = (files: any) => {
            return files.filter(
                (file: any) =>
                    file.type === 'image/png' || file.type === 'image/jpg'
            );
        };

        return {
            state,
            search,
            dense: ref(true),
            updateAvatar,
            checkFileType,
            file
        };
    }
});
</script>
